--  2005-2006 Daniel Santana
-- Resolution by Camera v.01
(
global rbcRolloutV
global rbcCameraList
global ResByCamera
--persistent global rbcCameraInfo
--persistent global rbcCameraRes
--persistent global rbcCameraBg
--persistent global rbcOptions
--persistent global rbcCameraLights

struct ResByCamStruct (upgrade, setupProperties, init, rbcRootNodeData, rbcData,
	CameraList,mainRollout, showMain, version, setCamRes)

ResByCamera = ResByCamStruct()
ResByCamera.version = "1.1(28/07/2006)"
-- Upgrades the old versions and deletes the globals
ResByCamera.upgrade = function upgrade =
(
	if not isProperty rootnode "rbcRootNodeData" then
	(
		if rbcCameraInfo != undefined then
		(
			format "Upgrading from global to custom properties...\n"
			var2 = rbcCameraInfo.count
			if var2 != 0 then
			(
				for i=1 to var2 do
				(
					cam = rbcCameraInfo[i]
					restmp = filterstring rbcCameraRes[i] "|"
					format "Updating camera %\n" cam
					lig = restmp[1]+"x"+restmp[2]
					bg = rbcCameraBg[i]
					format "Setting res % and bg %\n" lig bg
					camObject = getNodeByName cam exact:true
					if camObject != undefined then
					(
						if not isProperty camObject "rbcData" then
							custAttributes.add camObject ResByCamera.rbcData
						append camObject.rbcData.stCamRes lig
						append camObject.rbcData.stCamBg bg
					)
				)
			)
			persistents.remove #rbcCameraInfo
			persistents.remove #rbcCameraRes
			persistents.remove #rbcCameraBg
			persistents.remove #rbcOptions
			persistents.remove #rbcCameraLights
		)
		custAttributes.add rootnode ResByCamera.rbcRootNodeData
		rootnode.rbcRootNodeData.rbcVersion = 1.0
		rootnode.rbcRootNodeData.rbcOptions[2] = false
		rootnode.rbcRootNodeData.rbcOptions[1] = false
	)
)
-- Setup the custom attributes
ResByCamera.setupProperties = function setupProperties =
(
	ResByCamera.rbcRootNodeData = attributes rbcRootNodeData
		version:1
		attribID:#(0x12a5531f, 0x13000003)
	(
		parameters main rollout:blank
		(
			rbcversion type:#float animatable:false
			rbcoptions type:#boolTab tabSizeVariable:true animatable:false
		)
		rollout blank "Blank"
		(
		)
	)
	ResByCamera.rbcData = attributes rbcData
		version:1
		attribID:#(0x12a5531f, 0x13000004)
	(
		parameters main rollout:params
		(
			stCamRes type:#stringtab tabSizeVariable:true animatable:false
			stCamBg type:#stringtab tabSizeVariable:true animatable:false
		)
		rollout params "Camera resolution"
		(
			listBox lbx1 "Cam resolutions" width:144 height:7
			button btn1 "del"

			on params open do
			(
				lbx1.items = for i in stCamRes collect i
			)
			
			on lbx1 doubleclicked itm do
			(
				res = stCamRes[itm]
				tmp1 = filterString res "x"
				rbcWidth = tmp1[1]
				rbcHeight = tmp1[2] 
				renderWidth = rbcWidth as integer
				renderHeight = rbcHeight as integer
				renderSceneDialog.update()
				camObject = $
				bg = stCamBg[itm]
				if rootnode.rbcRootNodeData.rbcOptions[1] then viewport.setCamera camObject
				if rootnode.rbcRootNodeData.rbcOptions[2] and bg != undefined then
				(
					backgroundImageFileName = bg
					setBkgImageAspect #view
					viewport.DispBkgImage = true
					InvalidateAllBackgrounds()
				)
			)
			
			on btn1 pressed do
			(
				i = lbx1.selection
				if i != 0 and i != undefined then
				(
					tmp = stCamRes
					tmp = deleteItem tmp i
					tmp1 = stCamBg
					tmp1 = deleteItem tmp1 i
					stCamRes = tmp
					stCamBg = tmp1
					lbx1.items = for i in stCamRes collect i
				)
			)
		)
	)
)

ResByCamera.init = function init =
(
	ResByCamera.CameraList = #()
	for c in cameras where classof c != TargetObject do
	(
		if isProperty c "rbcData" then
		(
			for i in c.rbcData.stCamRes do
			(
				str = c.name + ":"+ i
				append ResByCamera.CameraList str
			)
		)
	)
)

fn evalBool str =
(
	if str == "true" then true
	else false
)

fn rbcArray2String arr = 
(
	str = ""
	for i = 1 to arr.count do (
		str = str + "\"" + (arr[i] as string) + "\", "						
	)
	str = trimright str ", "
	return str
)

ResByCamera.setCamRes = function setCamRes val =
(
	tmp1 = filterString ResByCamera.CameraList[val] ":"
	cam = tmp1[1]
	res = tmp1[2]
	tmp1 = filterString res "x"
	rbcWidth = tmp1[1]
	rbcHeight = tmp1[2] 
	renderWidth = rbcWidth as integer
	renderHeight = rbcHeight as integer
	camObject = getNodeByName cam exact:true
	bgIndex = findItem camObject.rbcData.stCamRes res
	bg = camObject.rbcData.stCamBg[bgIndex]
	if rootnode.rbcRootNodeData.rbcOptions[1] then viewport.setCamera camObject
	if rootnode.rbcRootNodeData.rbcOptions[2] and bg != undefined then
	(
		backgroundImageFileName = bg
		setBkgImageAspect #view
		viewport.DispBkgImage = true
		InvalidateAllBackgrounds()
	)
)

ResByCamera.mainRollout = rollout mainRollout "Camera resolution" width:608 height:256
(
	/*dotNetControl lv "Listview" pos: [5,5,0] width:600 height: 240
	button btnAdd "add" pos:[292,32] width:48 height:16
	button btnDel "del" pos:[292,56] width:48 height:16
	listbox lbx2 "Scene cameras" pos:[356,8] width:236 height:6
	spinner spn1 "" pos:[404,120] width:88 height:16 range:[0,100000,640] type:#integer scale:1
	spinner spn2 "" pos:[404,144] width:88 height:16 range:[0,100000,480] type:#integer scale:1
	label lbl1 "Width" pos:[356,120] width:40 height:16
	label lbl2 "Height" pos:[356,144] width:40 height:16
	button btnLoad "load" pos:[232,232] width:48 height:16
	button btnSave "save" pos:[288,232] width:48 height:16
	button btn4 "close" pos:[344,232] width:56 height:16
	button btnBatch "create batch" pos:[440,232] height:16
	checkbox chk1 "Set active view to camera" pos:[8,168] width:160 height:16
	checkbox chk2 "Set background" pos:[8,184] width:160 height:16
	label lbl3 " 2006 Daniel Santana" pos:[8,232] width:144 height:16*/

	listbox lbx1 "Camera list" pos:[8,8] width:268 height:10
	button btnAdd "add" pos:[292,32] width:48 height:16
	button btnDel "del" pos:[292,56] width:48 height:16
	listbox lbx2 "Scene cameras" pos:[356,8] width:236 height:6
	spinner spn1 "" pos:[404,120] width:88 height:16 range:[0,100000,640] type:#integer scale:1
	spinner spn2 "" pos:[404,144] width:88 height:16 range:[0,100000,480] type:#integer scale:1
	label lbl1 "Width" pos:[356,120] width:40 height:16
	label lbl2 "Height" pos:[356,144] width:40 height:16
	button btnLoad "load" pos:[232,232] width:48 height:16
	button btnSave "save" pos:[288,232] width:48 height:16
	button btn4 "close" pos:[344,232] width:56 height:16
	button btnBatch "create batch" pos:[440,232] height:16
	checkbox chk1 "Set active view to camera" pos:[8,168] width:160 height:16
	checkbox chk2 "Set background" pos:[8,184] width:160 height:16
	label lbl3 " 2005-2006 Daniel Santana" pos:[8,232] width:144 height:16
	
	on mainRollout open do
	(
		lbx1.items = ::ResByCamera.CameraList
		lbx2.items = sort (for o in cameras where classof o != TargetObject collect o.name)
		spn1.value = renderWidth
		spn2.value = renderHeight
		chk1.checked = rootnode.rbcRootNodeData.rbcOptions[1]
		chk2.checked = rootnode.rbcRootNodeData.rbcOptions[2]
	)
	on lbx1 doubleClicked itm do
	(
		ResByCamera.setCamRes itm
	)
	on btnAdd pressed do
	(
		cam = lbx2.selected
		camObject = getNodeByName cam exact:true
		if camObject != undefined then
		(
			if not isProperty camObject "rbcData" then
				custAttributes.add camObject ResByCamera.rbcData
			resName = (spn1.value as string) + "x" + (spn2.value as string)
			objName = lbx2.selected + ": " + resName
			append ResByCamera.CameraList objName
			append camObject.rbcData.stCamRes resName
			append camObject.rbcData.stCamBg backgroundImageFileName
			lbx1.items = ResByCamera.CameraList
		)
		else format "error: looking for camera %\n" cam
	)
	on btnDel pressed do
	(
		itm = findItem rbcCameraList (lbx1.selected)
		if rbcCameraList[itm] != undefined then deleteItem rbcCameraList itm
		if rbcCameraInfo[itm] != undefined then deleteItem rbcCameraInfo itm
		if rbcCameraRes[itm] != undefined then deleteItem rbcCameraRes itm
		if rbcCameraLights[itm] != undefined then deleteItem rbcCameraLights itm
		lbx1.items = rbcCameraList
	)
	on btnLoad pressed do
	(
		f = getOpenFilename caption:"Load selection" filename:"render_res.ini" types:"INI|*.ini"
		if f != undefined then
		(
			myIni = f
			str1 = (getINISetting myIni "RenderResolution" "Cameras")-- as StringStream
			str2 = (getINISetting myIni "RenderResolution" "Resolution")-- as StringStream
			str3 = (getINISetting myIni "RenderResolution" "Background")-- as StringStream
			str4 = (getINISetting myIni "RenderResolution" "Options")-- as StringStream
			str5 = (getINISetting myIni "RenderResolution" "Lights")-- as StringStream
			tmp1 = filterstring str1 "\","
			tmp2 = filterstring str2 "\","
			tmp3 = filterstring str3 "\","
			tmp4 = filterstring str4 "\","
			tmp5 = filterstring str5 "\","
			rbcCameraInfo = for o in tmp1 where o != " " collect o
			rbcCameraRes = for o in tmp2 where o != " " collect o
			rbcCameraBg = for o in tmp3 where o != " " collect o
			rbcOptions = for o in tmp4 where o != " " collect o
			rbcCameraList = #()
			rbcCameraLights = #()
			for i=1 to rbcCameraRes.count do
			(
				restmp = filterstring rbcCameraRes[i] "|"
				if restmp.count < 2 then continue
				if rbcCameraInfo[i] == undefined then tmp3 = "!Error!" + (i as string)
				else tmp3 = rbcCameraInfo[i]
				tmp4 = (tmp3  + ": " + restmp[1] + " x " + restmp[2])
				append rbcCameraList tmp4
			)
			for i=1 to tmp5.count do
			(
				if tmp5[i] == " " then continue
				restmp = filterstring tmp5[i] ":"
				append rbcCameraLights restmp
			)
			chk1.checked = rootnode.rbcRootNodeData.rbcOptions[1]
			chk2.checked = rootnode.rbcRootNodeData.rbcOptions[2]
			lbx1.items = rbcCameraList
		)
	)
	on btnSave pressed do
	(
		if rbcCameraList != 0 then
		(
			f = getSaveFilename caption:"Save selection" filename:"render_res.ini" types:"INI|*.ini"
			if f != undefined then
			(
				myIni = f
				str1 = ""
				str2 = ""
				str3 = ""
				str1 = rbcArray2String rbcCameraInfo
				str2 = rbcArray2String rbcCameraRes
				str3 = rbcArray2String rbcCameraBg
				str4 = rbcArray2String rbcOptions
				str5 = rbLightArray2String rbcCameraLights 
				setINISetting myIni "RenderResolution" "Options" str4
				setINISetting myIni "RenderResolution" "Cameras" str1
				setINISetting myIni "RenderResolution" "Resolution" str2
				setINISetting myIni "RenderResolution" "Background" str3
				setINISetting myIni "RenderResolution" "Lights" str5
			)
		)
	)
	on btn4 pressed do
	(
		destroydialog ResByCamera.mainRollout
	)
	on chk1 changed state do
	(
		rootnode.rbcRootNodeData.rbcOptions[1] = state
	)
	on chk2 changed state do
	(
		rootnode.rbcRootNodeData.rbcOptions[2] = state
	)
	
	on btnBatch pressed do
	(
		for i=1 to ResByCamera.CameraList.count do
		(
			tmp1 = filterString ResByCamera.CameraList[i] ":"
			cam = tmp1[1]
			res = tmp1[2]
			tmp1 = filterString res "x"
			rbcWidth = tmp1[1]
			rbcHeight = tmp1[2] 
			w = rbcWidth as integer
			h = rbcHeight as integer
			camObject = getNodeByName cam exact:true
			bgIndex = findItem camObject.rbcData.stCamRes res
			bg = camObject.rbcData.stCamBg[bgIndex]
			j = batchrendermgr.FindView cam
			if j > 0 then bview = batchrendermgr.GetView j
			else
			(
				bview = batchrendermgr.CreateView camObject
				bview.name = cam
			)
			bview.overridePreset = true
			bview.width = w 
			bview.height = h
			bview.outputFilename = (getDir #image) + "/png/" + cam + "_v0_.png"
		)
	)
)

ResByCamera.showMain = function showMain = (
	ResByCamera.setupProperties()
	ResByCamera.upgrade()
	ResByCamera.init()
	if ResByCamera.mainRollout != undefined then
	(
		--format "rollout.open:%\n" ResByCamera.mainRollout.open
		if ResByCamera.mainRollout.open == false then
		(
			format "Camera Resolution v %\n" ResByCamera.version
			createDialog ResByCamera.mainRollout
		)
	)
)
rbcRolloutV = ResByCamera.mainRollout
ResByCamera.showMain()
)